Private Sub item.placeRandomly()
	'randomly place the item (into a collision free spot)
	Dim As Integer emptylist(WCELLS*HCELLS), emptycount=0, isempty=0
	emptycount=0
	For yy As Integer =0 To HCELLS-1
		For xx As Integer =0 To WCELLS-1
			isempty=-1
			For p As Integer=0 To (*This._pc).player_count-1
				If ((*This._pc).player(p).dead)Then
					If (Not (*This._pc).dead_snake_collision)Then
						Continue For
					EndIf
				EndIf
				
				For i As Integer =0 To (*This._pc).player(p).length-1
					If (((*This._pc).player(p).body(i,0)=xx)and((*This._pc).player(p).body(i,1)=yy))Then
						isempty=0
						i=99999
						p=99999
					EndIf
				Next i
			Next p
			If (isempty)Then
				emptylist(emptycount)=xx+yy*(WCELLS)
				emptycount+=1
			EndIf
		Next xx
	Next yy
	
	Dim As Integer i_fp
	i_fp=emptylist(int(Rnd*(emptycount-1)))
	This.x=(i_fp Mod (WCELLS))
	This.y=int((i_fp-This.x)/(WCELLS))
End Sub

Private Sub item.draw()
	glColor3ub(0,0,0)
	glBegin(GL_QUADS)
		glVertex3f(This.x*ONEUNIT-BORDER,				This.y*ONEUNIT-BORDER,				-0.9f)
		glVertex3f(This.x*ONEUNIT+ONEUNIT+BORDER,		This.y*ONEUNIT-BORDER,				-0.9f)
		glVertex3f(This.x*ONEUNIT+ONEUNIT+BORDER,		This.y*ONEUNIT+ONEUNIT+BORDER,	-0.9f)
		glVertex3f(This.x*ONEUNIT-BORDER,				This.y*ONEUNIT+ONEUNIT+BORDER,	-0.9f)
	glEnd()
	
	glColor3ub(This.color(0),This.color(1),This.color(2))
	glBegin(GL_QUADS)
		glVertex3f(This.x*ONEUNIT,							This.y*ONEUNIT,						0.9f)
		glVertex3f(This.x*ONEUNIT+ONEUNIT,				This.y*ONEUNIT,						0.9f)
		glVertex3f(This.x*ONEUNIT+ONEUNIT,				This.y*ONEUNIT+ONEUNIT,				0.9f)
		glVertex3f(This.x*ONEUNIT,							This.y*ONEUNIT+ONEUNIT,				0.9f)
	glEnd()
End Sub

Private Sub item.setDefaults (ByRef _setting As Integer)
	This.setting=_setting
	Select Case As Const _setting
		Case ITEM_SNACK
			This.bonus=0
			This.counter=0
			This.score_increment=1
			This.length_increment=1
			This.speed_increment=0.02f
			This.color(0)=0
			This.color(1)=255
			This.color(2)=0
		Case ITEM_BONUS_SCORE
			This.bonus=1
			This.counter=50
			This.score_increment=2
			This.length_increment=1
			This.speed_increment=0.02f
			This.color(0)=200
			This.color(1)=200
			This.color(2)=255
		Case ITEM_BONUS_SPEED
			This.bonus=1
			This.counter=50
			This.score_increment=1
			This.length_increment=1
			This.speed_increment=-0.01f
			This.color(0)=255
			This.color(1)=200
			This.color(2)=200
		Case ITEM_BONUS_LENGTH
			This.bonus=1
			This.counter=50
			This.score_increment=1
			This.length_increment=-1
			This.speed_increment=0.02f
			This.color(0)=200
			This.color(1)=255
			This.color(2)=200
		Case ITEM_BONUS_SCORE_SPEED
			This.bonus=1
			This.counter=40
			This.score_increment=2
			This.length_increment=0
			This.speed_increment=-0.1f
			This.color(0)=255
			This.color(1)=200
			This.color(2)=255
		Case ITEM_BONUS_SCORE_LENGTH
			This.bonus=1
			This.counter=40
			This.score_increment=2
			This.length_increment=-1
			This.speed_increment=0.0f
			This.color(0)=200
			This.color(1)=255
			This.color(2)=255
		Case ITEM_BONUS_SPEED_LENGTH
			This.bonus=1
			This.counter=40
			This.score_increment=0
			This.length_increment=-1
			This.speed_increment=-0.1f
			This.color(0)=255
			This.color(1)=255
			This.color(2)=200
		Case ITEM_BONUS_SCORE_SPEED_LENGTH
			This.bonus=1
			This.counter=30
			This.score_increment=2
			This.length_increment=-1
			This.speed_increment=-0.1f
			This.color(0)=255
			This.color(1)=255
			This.color(2)=255
	End Select
End Sub