Enum
	SNAKE_RIGHT=0
	SNAKE_UP
	SNAKE_LEFT
	SNAKE_DOWN
End Enum

Type snake
	Public:
		pnum As Integer
		name As String =""
		color(3) As UByte 
		length As Integer =3
		speed As Single =0.3f
		direction As Integer =SNAKE_RIGHT
		dead As Integer =0
		
		_ic As item_controller_fwd Ptr
		parent As snake_controller_fwd Ptr
		
		obstacle_list As obstacle Ptr
		obstacle_count As Integer Ptr
		
		score As Integer =0
		
		body(WCELLS*HCELLS,2) As Integer
		
		Declare Sub setup()
		Declare Sub doStep()
		Declare Sub checkCollision()
		
		Declare Sub mapKey (ByRef _key As Integer, ByRef _keycode As Integer)
		Declare Sub handleEvents(ByRef _event As SDL_Event)
		
		Declare Sub triggerDie()
		
	Private:
		Declare Sub move()
		
		Declare Sub eat()
		Declare Sub digest()
		
		Declare Sub draw()
		
		Declare Sub triggerMove()
		Declare Sub triggerEat(ByRef _item As item)
		Declare Sub triggerDigest()
		
		Declare Function direction_queue_pop() As Integer
		
		speed_count As Single =0
		
		keyup As Integer =SDLK_UP
		keydown As Integer =SDLK_DOWN
		keyleft As Integer =SDLK_LEFT
		keyright As Integer =SDLK_RIGHT
		moved As Integer =0
		
		food_count As Integer=0
		food_queue(WCELLS,4) As Integer
		
		direction_queue_count As Integer =0
		direction_queue(10) As Integer
End Type
